%macro forcelabel(_Library, _Table_Name);
   %local __Chemin_Et_Programme__;
   %let __mNotes    = %sysfunc(getoption(NOTES));
   %let __OutPath__ = /home/&SysUserId.;
   options nonotes;
   proc sql;
       create table work.P1 as
           select name, label
           from dictionary.columns 
           where upcase(libname) = upcase("&_Library.") and 
                 upcase(memname) = upcase("&_Table_Name.");

       select  distinct trim(path)
       into    :__OutPath__
       from    dictionary.libnames
       where   libname = "WORK";
   quit;

   data _null_;
       ** Si on travaille sous Windows, il faut changer le "/" par un "\"... **;
       zz = trim(symget("__OutPath__")) || "/_z_AjusteLabel_z_&_Library._&_Table_Name..sas";
       call symput("__Chemin_Et_Programme__", zz);
   run;

   data work.p2 (keep = xxx);
       set work.p1 end = Last;
       format xxx $300.;
       if _n_ = 1 then do ;
           xxx = "proc datasets lib = &_Library. mt = data nolist;"; output;
           xxx = "    modify &_Table_Name.;"; output;
           xxx = "        label " || trim(name) || " = '" || trim(name) || "';"; output;
       end;
       else do;
           xxx = "        label " || trim(name) || " = '" || trim(name) || "';"; output;
       end;
       if Last then do;
           name = "";
           xxx = "quit;"; output;
       end;
   run;

   filename outfile "&__Chemin_Et_Programme__.";

   data _null_;                                                                        
       set  work.p2 end = EFIEOD;                                               
       %let _EFIERR_ = 0;
       %let _EFIREC_ = 0;
       file outfile delimiter = "09"x DSD DROPOVER;
       format xxx $300.;
       _EFIMIS_ = .;
       do;
           EFIOUT + 1;
           put xxx $;
           ;
       end;
       if _ERROR_ then call symput("_EFIERR_", 1);
       If EFIEOD  then call symput("_EFIREC_", EFIOUT);
   run;

   %inc outfile;

   filename outfile;
   options &__mNotes.;
%mend;

***********************************************************************************************************;
***                                            Fin du programme                                         ***;
***********************************************************************************************************;
